package ru.ulstu.report.service;

import org.springframework.stereotype.Service;
import ru.ulstu.aspirant.model.Aspirant;
import ru.ulstu.aspirant.service.AspirantService;
import ru.ulstu.report.model.Report;
import ru.ulstu.report.model.ReportPeriod;
import ru.ulstu.report.repository.ReportRepository;
import ru.ulstu.user.UserService;

import java.util.List;

@Service
public class ReportService {
    private final ReportRepository reportRepository;
    private final UserService userService;
    private final AspirantService aspirantService;

    public ReportService(ReportRepository reportRepository,
                         UserService userService,
                         AspirantService aspirantService) {
        this.reportRepository = reportRepository;
        this.userService = userService;
        this.aspirantService = aspirantService;
    }

    public List<Report> getReports(ReportPeriod reportPeriod) {
        return reportRepository.findAllByReportPeriod(reportPeriod);
    }

    public boolean canCreateReport(ReportPeriod reportPeriod) {
        Aspirant currentAspirant = aspirantService.getAspirantByUser(userService.getCurrentUser());
        return reportRepository.findByReportPeriodAndAspirant(reportPeriod, currentAspirant) == null;
    }
}
